//General Plugin Script

var
  Counter: integer;
  
function PluginCaption: string;
begin
  Result := 'Upgrade Attributes';
end;

function PluginHint: string;
begin
  Result := 'Upgrade Attributes';
end;

function PluginIcon: string;
begin
  Result := '';
end;

function PluginFlags: string;
begin
  Result := 'general';
end;

procedure PluginStart;
begin
  Counter := 0;
  GeoBusyStart;
  GeoBusyProgress(0, Geoget_MaxCount);
  GeoBusyCaption('Attributes Upgrade');
  GeoBusyKind('Upgrading old attibutes...');
end;

procedure PluginWork;
var
  n: integer;
  l: TStringList;
  s: string;
begin
  Counter := Counter + 1;
  GeoBusyProgress(Counter, Geoget_MaxCount);

  l := TStringList.create;
  try
    l.text := GC.TagValues('attribute');
    for n := 0 to l.count - 1 do
    begin
      s := IconToAttributeID(l[n]);
      if s <> '' then
        continue;
      s := AttributeToIcon(l[n]);
      if s = '' then
      begin
        if copy(lowercase(l[n]), 1, 3) = 'no ' then
        s := AttributeToIcon('-' + copy(l[n], 4, 256));
      end;
      if s <> '' then
        l[n] := s;
    end;
    GC.TagReplaceList('attribute', l);
  finally
    l.free;
  end;
end;

procedure PluginStop;
begin
  // Called on the end
end;
